<?
/*
 * Support classes to automaticaly generate simple DHTML menus.
 * See test.php for an example usage.
 * Made by Flupke - flupke@wanadoo.fr
 */

//////////////////////////////////////////////////////////////////////////////
// A menuitem, basically a text and a link ...
class fancyMenuItem {
  var $text;
  var $href;

  function fancyMenuItem($text, $href) {
    $this->text = $text;
    $this->href = $href;
  }

  function render($mouseOverManager = '', $mouseOutManager = '') {
    if ($this->href == '') {
      $element = 'span';
    } else {
      $element = 'a';
    }
    
    echo "<$element ";
    
    if ($mouseOverManager != '') {
      echo "onmouseover=\"$mouseOverManager\" ";
    }

    if ($mouseOutManager != '') {
      echo "onmouseout=\"$mouseOutManager\" ";
    }
    
    if ($this->href != '') {
      echo "href=\"{$this->href}\"";
    }
    
    echo ">{$this->text}</$element>";
  }    
}

//////////////////////////////////////////////////////////////////////////////
// A menu, composed from a title and a list of menu items
class fancyMenu {  
  var $title;
  var $menuItems;

  // create the menu with the given title
  function fancyMenu($titleText, $titleHref) {
    $this->title = new fancyMenuItem($titleText, $titleHref);
    $this->menuItems = array();
  }
  
  // add an item to the list
  function addItem($item) {
    $this->menuItems[] = $item;
  }
  
  // echoes the items list (the title is rendered in the menubar manager)
  function render($id, $mouseOverManager = '', $mouseOutManager = '') {    
    echo "<div id=\"$id\" ";
    if ($mouseOverManager != '') {
      echo "onmouseover=\"$mouseOverManager\" ";
    }
    if ($mouseOutManager != '') {
      echo "onmouseout=\"$mouseOutManager\" ";
    }    
    echo "class=\"fancyMenu\">";
    echo "<table>";
    foreach ($this->menuItems as $item) {
      echo "<tr><td>";
      $item->render();
      echo "</td></tr>";
    }
    echo "</table>";
    echo "</div>";
    
    return $res;
  }
}

//////////////////////////////////////////////////////////////////////////////
// A menu bar, grouping menus
class fancyMenuBar {
  var $menus;

  function fancyMenuBar() {
  }
  
  function addMenu($menu) {
    $this->menus[] = $menu;
  }  

  function render() {
    // render the javascript support
    echo "<script type=\"text/javascript\">\n";
    $i = 0;
    foreach ($this->menus as $menu) {
      echo "menu$i = new fancyMenu('menu{$i}Title', 'menu{$i}Items', 'menuPosRef');\n";
      $i++;
    }
    echo "</script>\n";
      
    // put everything in a relative positionning environnement
    echo '<div style="position: relative;">';
    
    // first we render the top menu bar
    echo "<div id=\"menuBar\" class=\"fancyMenuBar\">";
    echo "<table><tr>";
    $i = 0;
    foreach ($this->menus as $menu) {
      echo "<td id=\"menu{$i}Title\">";
      $menu->title->render("menu$i.showMenu()", "menu$i.hideMenu()");
      echo "</td>";
      $i++;
    }    
    echo "</tr></table>";
    echo "</div>";

    // add an empty menu container that will be used as a position reference for the other menus
    echo '<div id="menuPosRef" class="fancyMenuBar"></div>';
    
    // then, render the menu containers
    $i = 0;
    foreach ($this->menus as $menu) {
      $menu->render("menu{$i}Items", "menu$i.showMenu()", "menu$i.hideMenu()");
      $i++;
    }

    echo '</div>';
  }  
  
  function clear() {
    $this->menus = array();
  }
  
  function loadFromArray($data) {
    $this->clear();
    $i = 0;
    foreach ($data as $menu) {
      $this->menus[$i] = new fancyMenu(key($menu), current($menu));
      next($menu);
      foreach (current($menu) as $text => $link) {        
        $this->menus[$i]->addItem(new fancyMenuItem($text, $link));
      }
      $i++;
    }
  } 
}
?>
